//
//  IDLRequestHeader.m
//  IDLExplorer
//
//  Created by Victor Ananiev on Thu May 22 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "IDLRequestHeader.h"
#import "CORBAObject_Private.h"
#import "IDLIOPProfile.h"
#import "IDLProfileBody.h"
#import <IDL.h>
#import "VXMessageHandler.h"

@implementation IDLRequestHeader

- init
{
    self = [super init];
    
    return self;
}

- (void) dealloc
{
    [_service_context release];
    [_operation release];
    [_targetObject release];
    [super dealloc];
}

- (void) _setRequest_id:(NSNumber*)value
{
    _requestId = [value unsignedLongValue];
}

- (NSNumber*) _request_id
{
    return [NSNumber numberWithUnsignedLong:_requestId];
}

- (NSNumber*) request_id
{
    return [NSNumber numberWithUnsignedLong:_requestId];
}

- (void) _setResponse_expected:(NSNumber*)value
{
    _responseExpected = [value boolValue];
}

- (BOOL) responseExpected
{
    return _responseExpected;
}

- (void) _setResponse_flags:(NSData*)value
{
    const char* bytes = [value bytes];
    _responseExpected = bytes[0] & 0x01;
}

- (void) _setReserved:value
{
// ignore
}

- (void) _setObject_key:(NSData*)objId
{
    _targetObject = [[CORBAObject lookupObjectID:objId]retain];
}

- (void) _setTarget:target
{
    switch([[target valueForKey:VXUnionDescriptorKey]shortValue]){
        case 0:{
            NSData* objId = [target valueForKey:VXUnionDataKey];
            _targetObject = [[CORBAObject lookupObjectID:objId]retain];
        }
        break;
        
        
        case 1:{
            IDLIOPProfile* profile = [target valueForKey:VXUnionDataKey]; //TaggedProfile
            unsigned long tag = [profile tag];
            if(tag == TAG_INTERNET_IOP){
                IDLProfileBody* body = [profile profileBody];
                //NSArray* components = [body components];
                //NSString* host = [body hostName];
                //unsigned port = [body portNumber];
                NSData* objId = [body objectID];
#warning FixMe: Don't check host & port in RequestHeader target (case 1)
                if(objId)
                    _targetObject = [[CORBAObject lookupObjectID:objId]retain];
            }else
                [CORBAException raise:@"NO_IMPLEMENT" 
                    minorCode:ProfileIdNotSupported completed:CORBA_CompletedNo];
        }
        break;
        
        case 2:{
#warning FixMe: GIOP 1.2, RequestHeader target (case 2) not fully implemented
            // value is a dictionary with 'ior' and 'CORBAObject'
            // The CORBAObject has different profile and does not match local object!
            NSDictionary* addrInfo = [target valueForKey:VXUnionDataKey]; 
            //unsigned long i = [[addrInfo valueForKey:@"selected_profile_index"]unsignedLongValue];
            _targetObject = [addrInfo valueForKey:@"ior"]; // CORBAObject or local
            if([_targetObject isKindOfClass:[CORBAObject class]])
                [_targetObject retain];
            else
                _targetObject = [[CORBAObject lookupImplementation:_targetObject]retain];
            if(!_targetObject){
                // Either iorObj has multiple TAG_INTERNET_IOP profiles or it is not ours
                NSLog(@"CORBAInvalidObjectReference: GIOP 1.2: RequestHeader/ReferenceAddr - cannot locate object. Either the object is not here or 'ReferenceAddr' has multiple TAG_INTERNET_IOP profiles, which is not supported");
                        
                [CORBAException raise:@"INV_OBJREF" minorCode:ProfileError completed:NO];
            }
        }
        break;
    }

}

- (void) _setOperation:(NSString*)op
{
    _operation = [op retain];
}

- (void) _setRequesting_principal:rqp
{
// ignore
}

- (CORBAObject*) targetObject
{
    return _targetObject;
}

- (NSString*) operation
{
    return _operation;
}

@end
