/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import <Foundation/Foundation.h>

@class VXMessageHeader, IDLOctetStream, IDLGIOPVersion;

enum _msg_type {
    GIOP_RequestType,
    GIOP_ReplyType,
    GIOP_CancelRequestType,
    GIOP_LocateRequestType,
    GIOP_LocateReplyType,
    GIOP_CloseConnectionType,
    GIOP_MessageErrorType,
    GIOP_FragmentType
};

@interface VXMessage : NSObject
{
@private
    VXMessageHeader* _header;
    IDLOctetStream* _stream;
	id _invocation;
}

- initWithMessageType:(unsigned)msgType iiopVersion:(IDLGIOPVersion*)version;
- initWithStream:(IDLOctetStream*)stream header:(VXMessageHeader*)header;
+ requestWithIIOPVersion:(IDLGIOPVersion*)iiopVersion;
- (IDLOctetStream*) stream;
- (void) sendWithConnection:connection;
- (unsigned long) minorVersion;
- (unsigned long) majorVersion;
- (IDLGIOPVersion*)iiopVersion;
- (unsigned long) messageType;

- (long) requestId;
- peepHeader;

- (void) alignStreamBody;

- invocationObject;
- (void) setInvocationObject:object;
@end
